/*[Parámetros de la rótula]*/

//Diámetro del primer tubo que va a utilizar (conviene darle entre 0.2 y 0.4mm de más)
Tubo_1 = 22.3;

//Diámetro del segundo tubo que va a utilizar (conviene darle entre 0.2 y 0.4mm de más)
Tubo_2 = 16.3;

//Diámetro que desea para la mordaza (debe estar acorde con el diámetro del tubo que se va a utilizar)
Diametro = 58;

//Milímetros de planificado que desea en los extremos (para facilitar su impresión sin soportes)
Plano = 3;

//Diámetro del tornillo que va a utilizar (conviene darle entre 0.2 y 0.4mm de más)
Tornillo = 6.3;

//Diámetro de la cabeza del tornillo que va a utilizar (conviene darle entre 0.2 y 0.4mm de más)
Cabeza = 10;

//Grosor de la cabeza del tornillo que va a utilizar
Grosor_Cabeza = 6;

//Diámetro de la tuerca que va a utilizar en su parte más ancha (conviene darle entre 0.2 y 0.4mm de más)
Tuerca = 11.5;

//Grosor de la tuerca que va a utilizar
Grosor_Tuerca = 5;

//Refinamiento que se desea para las partes redondeadas (a mayor refinamiento, mayor será el tiempo de renderización)
Suavizado = 40;


/*[Parámetros del tapón]*/
// Diámetro exterior del tubo
D_E = 12;

// Diámetro interior del tubo
D_I = 10;


/*[Mostrar]*/
//Elementos que desea mostrar para su impresión
Mostrar = "Hembra";     //[Todo:Todos los elementos, Macho:Pieza que lleva el tornillo, Hembra:Pieza que lleva la tuerca, Soporte:Pieza de unión con el encaje del soporte de la tablet,Tapon:Tapón]




/*[Hidden]*/
Alto_1 = Tubo_1+14;
Alto_2 = Tubo_2+14;
Achaflanado = 10;


module Tapon() {
difference() {
minkowski() {
    cylinder(d=D_E-3,h=1,$fn=200);
sphere(d=3,$fn=100);
}
translate([0,0,2]) cube([D_E+5,D_E+5,2],center=true);
}


translate([0,0,1]) difference() {
    cylinder(d1=D_I,h=7,d2=D_I-1,$fn=200);
        translate([0,0,-2]) cylinder(d=D_I-2,h=10,$fn=200);
}
}


module Cuna() {
  translate([0, 0, 0])
      rotate_extrude($fn=Suavizado)
          translate([Diametro/2-3, 0])
            polygon( points=[[0,0],[6,0],[5.25,2],[4.5,0.1],[3.75,2],[3,0.1],[2.25,2],[1.5,0.1],[0.75,2]] );
}




module Macho() {
difference() {
minkowski() {
cylinder(Alto_1-Achaflanado*2,d=Diametro-Achaflanado*2,center=true,$fn=Suavizado);
sphere(Achaflanado,$fn=Suavizado);
}

rotate([90,0,0]) translate([Diametro/2-Tubo_1/2-3,Alto_1/2-Tubo_1/2-3,0]) cylinder(Diametro+10,d=Tubo_1,center=true,$fn=Suavizado);
translate([0,0,-Tubo_1-4.85]) cube([Diametro+10,Diametro+10,Alto_1],center=true);
translate([-Diametro/2+Diametro/3,0,Alto_1/2-3-Tubo_1/2]) cube([Diametro,Diametro,1.5],center=true);
cylinder(Alto_1+10,d=Tornillo,center=true,$fn=Suavizado);
translate([0,0,Alto_1/2-Grosor_Cabeza/2+0.5]) cylinder(Grosor_Cabeza+1,d=Cabeza,center=true,$fn=Suavizado);
translate([0,Diametro-Plano,0]) cube([Diametro,Diametro,Alto_1+10],center=true);
translate([0,-Diametro+Plano,0]) cube([Diametro,Diametro,Alto_1+10],center=true);
}

difference() {
union() {
translate([0,0,-Alto_1/2+9.15]) rotate([0,180,0]) resize([Diametro,Diametro,0]) Cuna();
translate([0,0,-Alto_1/2+8.201]) difference() {
cylinder(2.1,d=Diametro,center=true,$fn=Suavizado);
cylinder(3,d=Diametro-1.327,center=true,$fn=Suavizado);
}
}
translate([0,Diametro-Plano,0]) cube([Diametro,Diametro,Alto_1+10],center=true);
translate([0,-Diametro+Plano,0]) cube([Diametro,Diametro,Alto_1+10],center=true);
}

}


module Hembra() {
difference() {
minkowski() {
cylinder(Alto_2-Achaflanado*2,d=Diametro-Achaflanado*2,center=true,$fn=Suavizado);
sphere(Achaflanado,$fn=Suavizado);
}

rotate([90,0,0]) translate([Diametro/2-Tubo_2/2-3,Alto_2/2-Tubo_2/2-3,0]) cylinder(Diametro+10,d=Tubo_2,center=true,$fn=Suavizado);
translate([0,0,-Tubo_2-4.85]) cube([Diametro+10,Diametro+10,Alto_2],center=true);
translate([-Diametro/2+Diametro/3,0,Alto_2/2-3-Tubo_2/2]) cube([Diametro,Diametro,1.5],center=true);
cylinder(Alto_2+10,d=Tornillo,center=true,$fn=Suavizado);
translate([0,0,Alto_2/2-Grosor_Tuerca/2+0.5]) rotate([0,0,90]) cylinder(Grosor_Tuerca+1,d=Tuerca,center=true,$fn=6);
translate([0,Diametro-Plano,0]) cube([Diametro,Diametro,Alto_2+10],center=true);
translate([0,-Diametro+Plano,0]) cube([Diametro,Diametro,Alto_2+10],center=true);
}

difference() {
translate([0,0,-Alto_2/2+9.15]) rotate([0,180,0]) resize([Diametro-1.3,Diametro-1.3,0]) Cuna();

translate([0,0,-Alto_2/2+8.201]) difference() {
cylinder(2.1,d=Diametro,center=true,$fn=Suavizado);
cylinder(3,d=Diametro-2,center=true,$fn=Suavizado);
}

translate([0,Diametro-Plano,0]) cube([Diametro,Diametro,Alto_2+10],center=true);
translate([0,-Diametro+Plano,0]) cube([Diametro,Diametro,Alto_2+10],center=true);
}

difference() {
translate([0,0,-Alto_2/2+8.5]) cylinder(1.5,d=Diametro-10.5,center=true,$fn=Suavizado);
translate([-Diametro/2+Diametro/3,0,Alto_2/2-3-Tubo_2/2]) cube([Diametro,Diametro,1.5],center=true);
cylinder(Alto_2+10,d=Tornillo,center=true,$fn=Suavizado);
}
}




module Soporte() {
difference() {
minkowski() {
cylinder(Alto_2-Achaflanado*2,d=Diametro-Achaflanado*2,center=true,$fn=Suavizado);
sphere(Achaflanado,$fn=Suavizado);
}

*rotate([90,0,0]) translate([Diametro/2-Tubo_2/2-3,Alto_2/2-Tubo_2/2-3,0]) cylinder(Diametro+10,d=Tubo_2,center=true,$fn=Suavizado);
translate([0,0,-Tubo_2-4.85]) cube([Diametro+10,Diametro+10,Alto_2],center=true);
translate([0,0,Tubo_2+4.85]) cube([Diametro+10,Diametro+10,Alto_2],center=true);
cylinder(Alto_2+10,d=Tornillo,center=true);
translate([0,0,Tubo_2/2-Grosor_Tuerca/2-3.55]) rotate([0,0,90]) cylinder(Grosor_Tuerca+3,d=Tuerca,center=true,$fn=6);
translate([0,Diametro-Plano-2,0]) cube([Diametro,Diametro,Alto_2+10],center=true);
translate([0,-Diametro+Plano+2,0]) cube([Diametro,Diametro,Alto_2+10],center=true);

translate([-9,0,Alto_2/2]) cylinder(Alto_2,d=4.3,center=true,$fn=Suavizado);
translate([9,-10,Alto_2/2]) cylinder(Alto_2,d=4.3,center=true,$fn=Suavizado);
translate([9,10,Alto_2/2]) cylinder(Alto_2,d=4.3,center=true,$fn=Suavizado);

translate([-9,0,Tubo_2/2-3.4/2-4.15]) cylinder(3.4,d=8,center=true,$fn=6);
translate([9,-10,Tubo_2/2-3.4/2-4.15]) cylinder(3.4,d=8,center=true,$fn=6);
translate([9,10,Tubo_2/2-3.4/2-4.15]) cylinder(3.4,d=8,center=true,$fn=6);

translate([-20-9,0,Tubo_2/2-3.4/2-4.15]) cube([40,6.927,3.4],center=true);
translate([20+9,-10,Tubo_2/2-3.4/2-4.15]) cube([40,6.927,3.4],center=true);
translate([20+9,10,Tubo_2/2-3.4/2-4.15]) cube([40,6.927,3.4],center=true);
}

difference() {
translate([0,0,-Alto_2/2+9.15]) rotate([0,180,0]) resize([Diametro-1.3,Diametro-1.3,0]) Cuna();

translate([0,0,-Alto_2/2+8.201]) difference() {
cylinder(2.1,d=Diametro,center=true,$fn=Suavizado);
cylinder(3,d=Diametro-2,center=true,$fn=Suavizado);
}

translate([0,Diametro-Plano-2,0]) cube([Diametro,Diametro,Alto_2+10],center=true);
translate([0,-Diametro+Plano+2,0]) cube([Diametro,Diametro,Alto_2+10],center=true);
}

difference() {
translate([0,0,-Alto_2/2+8.5]) cylinder(1.5,d=Diametro-10.5,center=true,$fn=Suavizado);
translate([-Diametro/2+Diametro/3,0,Alto_2/2-3-Tubo_2/2]) cube([Diametro,Diametro,1.5],center=true);
cylinder(Alto_2+10,d=Tornillo,center=true,$fn=Suavizado);
}
}


if (Mostrar=="Todo") {
rotate([-90,0,0]) translate([-Diametro/2-10,0,0]) difference() {
Macho();
translate([0,Diametro/2+Alto_1/2-Plano-2,-Diametro/2-2]) rotate([30,0,0]) cube([Diametro,Diametro,Diametro],center=true);
}

rotate([-90,0,0]) translate([Diametro/2+10,0,0]) difference() {
Hembra();
translate([0,Diametro/2+Alto_2/2-Plano-2,-Diametro/2-2]) rotate([30,0,0]) cube([Diametro,Diametro,Diametro],center=true);
}


translate([0,-Diametro/2-10,0]) rotate([-90,0,0]) difference() {
Soporte();
translate([0,Diametro/2+Alto_2/2-Plano-2,-Diametro/2-2]) rotate([30,0,0]) cube([Diametro,Diametro,Diametro],center=true);
}

translate([0,Diametro/2,-Diametro/2+4.5])Tapon();
}

if (Mostrar=="Hembra") {
rotate([-90,0,0]) difference() {
Hembra();
translate([0,Diametro/2+Alto_2/2-Plano-2,-Diametro/2-2]) rotate([30,0,0]) cube([Diametro,Diametro,Diametro],center=true);
}
}


if (Mostrar=="Macho") {
rotate([-90,0,0]) difference() {
Macho();
translate([0,Diametro/2+Alto_1/2-Plano-2,-Diametro/2-2]) rotate([30,0,0]) cube([Diametro,Diametro,Diametro],center=true);
}
}


if (Mostrar=="Soporte") {
rotate([-90,0,0]) difference() {
Soporte();
translate([0,Diametro/2+Alto_2/2-Plano-2,-Diametro/2-2]) rotate([30,0,0]) cube([Diametro,Diametro,Diametro],center=true);
}
}


if (Mostrar=="Tapon") {
Tapon();
}


