use<threads.scad>



/*[Medidas de la tablet]*/

//Largo total de la tablet
Largo = 281;

//Ancho total de la tablet
Ancho = 216;

//Altura total de la tablet
Alto = 6.5;


/*[Medidas del soporte]*/

//Grosor de la base del soporte
Grosor_Inferior = 4;

//Grosor de la parte superior del soporte
Grosor_Superior = 3;

//Reborde que sujetará la tablet por arriba
Reborde = 3;

//Radio del redondeo que se quiere en las esquinas (los laterales tendrán 1.5 veces este grosor)
Redondeo = 3;


/*[Aperturas laterales]*/

//Largo de la apertura izquierda 1
Sl1I = 40;

//Distancia desde el extremo inferior de la tablet al principio de la apertura izquierda 1
Dist1I = 25;

//Largo de la apertura izquierda 2
Sl2I = 58;

//Distancia desde el extremo inferior de la tablet al principio de la apertura izquierda 2
Dist2I = 148;

//Largo de la apertura izquierda 3
Sl3I = 16;

//Distancia desde el extremo inferior de la tablet al principio de la apertura izquierda 3
Dist3I = 100;

//Largo de la apertura derecha 1
Sl1D = 40;

//Distancia desde el extremo inferior de la tablet al principio de la apertura derecha 1
Dist1D = 25;

//Largo de la apertura derecha 2
Sl2D = 40;

//Distancia desde el extremo inferior de la tablet al principio de la apertura derecha 2
Dist2D = 147;

//Largo de la apertura derecha 3
Sl3D = 0;

//Distancia desde el extremo inferior de la tablet al principio de la apertura derecha 3
Dist3D = 0;

//Largo de la apertura inferior 1
Sl1A = 7;

//Distancia desde el extremo inferior de la tablet al principio de la apertura inferior 1
Dist1A = 137;

//Largo de la apertura inferior 2
Sl2A = 0;

//Distancia desde el extremo inferior de la tablet al principio de la apertura inferior 2
Dist2A = 0;


//Diámetro de la apertura de la cámara
Dia_Camara = 15;

//Distancia desde el extremo izquierdo de la tablet al centro de la cámara
Distx_Camara = 141;


//Distancia desde el extremo superior de la tablet al centro de la cámara
Disty_Camara = 13;


/*[Elementos a mostrar]*/

//Elementos que desea mostrar para su impresión
Mostrar = "Soporte";    //[ Soporte:Soporte para la tablet, Tope:Tope superior del soporte, Fijacion:Fijación del soporte, Encaje:Pieza de encaje para el soporte, Tirador:Tirador del tope, Casquillo:Casquillo para el tornillo, Cierre:Cierre superior del soporte]


//Suavizado para todas las partes redondeadas
Suavizado = 40;


/*[Hidden]*/



module Tornillo() {
    cylinder(h= 20,d=3.3,$fn=Suavizado);
    translate([0,0,19.999]) cylinder(h=2.5,d1=3.5,d2=6.4,$fn=Suavizado);
}


module Tornillo4() {
    cylinder(h=20,d=4.4,$fn=Suavizado);
    translate([0,0,19.999]) cylinder(h=3.2,d1=4.5,d2=8.1,$fn=Suavizado);
}



module Carcasa() {
    difference() {
        hull() {
            translate([Largo/2+Redondeo,Ancho/2,-Alto/2+Redondeo/2-Grosor_Inferior]) sphere(d=Redondeo,$fn=Suavizado);
            translate([-Largo/2-Redondeo,Ancho/2,-Alto/2+Redondeo/2-Grosor_Inferior]) sphere(d=Redondeo,$fn=Suavizado);
            translate([Largo/2+Redondeo,-Ancho/2,-Alto/2+Redondeo/2-Grosor_Inferior]) sphere(d=Redondeo,$fn=Suavizado);
            translate([-Largo/2-Redondeo,-Ancho/2,-Alto/2+Redondeo/2-Grosor_Inferior]) sphere(d=Redondeo,$fn=Suavizado);
            translate([Largo/2+Redondeo,Ancho/2,Alto/2-Redondeo/2+Grosor_Superior]) sphere(d=Redondeo,$fn=Suavizado);
            translate([-Largo/2-Redondeo,Ancho/2,Alto/2-Redondeo/2+Grosor_Superior]) sphere(d=Redondeo,$fn=Suavizado);
            translate([Largo/2+Redondeo,-Ancho/2,Alto/2-Redondeo/2+Grosor_Superior]) sphere(d=Redondeo,$fn=Suavizado);
            translate([-Largo/2-Redondeo,-Ancho/2,Alto/2-Redondeo/2+Grosor_Superior]) sphere(d=Redondeo,$fn=Suavizado);
        }
                translate([0,Reborde+Redondeo/2,0]) cube([Largo,Ancho+Reborde*2,Alto],center=true);
                translate([0,0,Alto/2+Grosor_Superior/2]) cube([Largo-Reborde*2,Ancho-Reborde*2-Redondeo,Alto+Grosor_Superior],center=true);
//Tornillos de placa de Fijación
                translate([-30,15,-Alto/2-22.4]) Tornillo();
                translate([30,15,-Alto/2-22.4]) Tornillo();
                translate([0,-15,-Alto/2-22.4]) Tornillo();
//Tuercas de placa de seguimiento visual
                translate([-19,-Ancho/2+30,-Alto/2-2.69]) cylinder(h=2.7,d=6.1,$fn=6);
                translate([-19,-Ancho/2+30,-Alto/2-2.69]) cylinder(h=Grosor_Inferior+20,d=3.3,center=true,$fn=Suavizado);
                translate([19,-Ancho/2+30,-Alto/2-2.69]) cylinder(h=2.7,d=6.1,$fn=6);
                translate([19,-Ancho/2+30,-Alto/2-2.69]) cylinder(h=Grosor_Inferior+20,d=3.3,center=true,$fn=Suavizado);
//Tuercas del tope superior
                translate([30,Ancho/2-50,-Alto/2-2.69]) cylinder(h=2.7,d=6.1,$fn=6);
                translate([30,Ancho/2-50,-Alto/2-2.69]) cylinder(h=Grosor_Inferior+20,d=3.3,center=true,$fn=Suavizado);
                translate([-30,Ancho/2-50,-Alto/2-2.69]) cylinder(h=2.7,d=6.1,$fn=6);
                translate([-30,Ancho/2-50,-Alto/2-2.69]) cylinder(h=Grosor_Inferior+20,d=3.3,center=true,$fn=Suavizado);
    }
}


module Soporte() {
    difference() {
        Carcasa();
//Aperturas laterales izquierdas
            translate([-Largo/2,Sl1I/2-Ancho/2+Redondeo/2+Dist1I,0]) cube([20,Sl1I,Alto],center=true);
            translate([-Largo/2,Sl2I/2-Ancho/2+Redondeo/2+Dist2I,0]) cube([20,Sl2I,Alto],center=true);
            translate([-Largo/2,Sl3I/2-Ancho/2+Redondeo/2+Dist3I,0]) cube([20,Sl3I,Alto],center=true);
//Aperturas laterales derechas
            translate([Largo/2,Sl1D/2-Ancho/2+Redondeo/2+Dist1D,0]) cube([20,Sl1D,Alto],center=true);
            translate([Largo/2,Sl2D/2-Ancho/2+Redondeo/2+Dist2D,0]) cube([20,Sl2D,Alto],center=true);
            translate([Largo/2,Sl3D/2-Ancho/2+Redondeo/2+Dist3D,0]) cube([20,Sl3D,Alto],center=true);
//Aperturas inferiores
            translate([Sl1A/2-Largo/2+Dist1A,-Ancho/2,0]) cube([Sl1A,20,Alto],center=true);
            translate([-Largo/2+Dist2A,-Ancho/2,0]) cube([Sl2A,20,Alto],center=true);
//Aperturas de la cámara
            translate([-Largo/2+Distx_Camara,Ancho/2-Disty_Camara,-Alto/2-Grosor_Inferior/2]) cylinder(h=Grosor_Inferior+10,d=Dia_Camara,center=true,$fn=Suavizado);
    }
}


module Fijacion() {
    difference() {
        hull() {
            translate([0, 0, 0]) linear_extrude(0.01)
                polygon( points=[[-41,20],[41,20],[37,-20],[-37,-20]] );

            translate([0, 0, 4]) linear_extrude(0.01)
                polygon( points=[[-37,20],[37,20],[33,-20],[-33,-20]] );
        }
//Tuercas y tornillos de placa de Fijación
            translate([-30,15,-10]) Tornillo();
            translate([30,15,-10]) Tornillo();
            translate([0,-15,-10]) Tornillo();
            translate([0,-15,2.5/1.9]) cylinder(h=2.71,d=6.1,$fn=6,center=true);
            translate([-30,15,2.5/1.9]) cylinder(h=2.71,d=6.1,$fn=6,center=true);
            translate([30,15,2.5/1.9]) cylinder(h=2.71,d=6.1,$fn=6,center=true);
            translate([32,7-2.3,2]) cylinder(h=10,d=5.7,center=true,$fn=Suavizado);
    }
}


module Resta_Encaje() {
    hull() {
        translate([0, 0, 0]) linear_extrude(0.01)
            polygon( points=[[-41.2,20],[41.2,20],[37.2,-20],[-37.2,-20]] );
        translate([0, 0, 4]) linear_extrude(0.01)
            polygon( points=[[-37.2,20],[37.2,20],[33.2,-20],[-33.2,-20]] );
    }
}

module Encaje() {
    difference() {
        scale([1.2,1.1,2.5]) Resta_Encaje();
            translate([0,2,6.016]) Resta_Encaje();
            translate([-10,9,-17.182]) Tornillo4();
            translate([10,9,-17.182]) Tornillo4();
            translate([0,-9,-17.182]) Tornillo4();
            translate([32,7,4]) cylinder(h=15,d=5.7,center=true,$fn=Suavizado);
            translate([32,7,-0.5])
                metric_thread(diameter=10.5, pitch=1, length=5, internal=true, n_starts=1);
    }
}



module Tirador() {
    translate([0,0,0]) difference() {
        minkowski() {
            translate([0,0,0]) cylinder(h=3,d=13,center=true,$fn=Suavizado);
            sphere(2,$fn=40);
        }
            translate([0,0,3.5]) cylinder(h=4,d=18,center=true,$fn=Suavizado);
            translate([0,0,0]) cylinder(h=15,d=3.3,center=true,$fn=Suavizado);
            translate([0,0,-2]) cylinder(h=3.2,d=5.8,center=true,$fn=Suavizado);
    }
}


module Tope() {
    difference() {
        union() {
            translate([0,0,-4]) cylinder(h=8,d=10,center=true,$fn=Suavizado);
            translate([0,0,0])
                metric_thread(diameter=10, pitch=1, length=4.5, internal=false, n_starts=1);
        }
            translate([0,0,1]) cylinder(h=15,d=5.6,center=true,$fn=Suavizado);
            translate([0,0,0]) cylinder(h=20,d=3.5,center=true,$fn=Suavizado);
    }
}


module Casquillo() {
    difference() {
        translate([0,0,0]) cylinder(h=6,d=5.4,center=true,$fn=Suavizado);
            translate([0,0,-5])
                metric_thread(diameter=3.3, pitch=0.5, length=10, internal=true, n_starts=1);
    }
}


module Ranura() {
    hull() {
        translate([0,23,-0.4]) cylinder(h=2.5,d1=3.5,d2=6.4,$fn=Suavizado);
        translate([0,-7,-0.4]) cylinder(h=2.5,d1=3.5,d2=6.4,$fn=Suavizado);
    }
    hull() {
        translate([0,23,0]) cylinder(h=7,d=3.5,center=true,$fn=Suavizado);
        translate([0,-7,0]) cylinder(h=7,d=3.5,center=true,$fn=Suavizado);
    }
}


module Cierre() {
    difference() {
        union() {
            difference() {
                minkowski() {
                    cube([64,52,3],center=true);
                    cylinder(h=1,d=8,center=true,$fn=Suavizado);
                }
//Ranuras guía
                    translate([30,0,0]) rotate([180,0,0]) Ranura();
                    translate([-30,0,0]) rotate([180,0,0]) Ranura();
            }

            translate([0,30,0]) cube([50,40,4],center=true);
        }
            hull() {
                translate([-Largo/2+Distx_Camara,34,-3]) cylinder(h=6,d=Dia_Camara+4,$fn=Suavizado);
                translate([-Largo/2+Distx_Camara,22,-3]) cylinder(h=6,d=Dia_Camara+4,$fn=Suavizado);
            }
    }

    difference() {
        translate([0,46,Grosor_Inferior+5]) cube([50,8,Alto-1],center=true);
            translate([0,38.5,Grosor_Inferior+5]) rotate([-40,0,0]) cube([52,25,Alto-1],center=true);
    }
    translate([0,48,Grosor_Inferior]) cube([50,4,Alto-1],center=true);
}



if (Mostrar=="Soporte") {
    Soporte();
}

if (Mostrar=="Fijacion") {
    rotate([0,180,0]) Fijacion();
}

if (Mostrar=="Encaje") {
Encaje();
}

if (Mostrar=="Tirador") {
Tirador();
}

if (Mostrar=="Tope") {
Tope();
}

if (Mostrar=="Casquillo") {
Casquillo();
}

if (Mostrar=="Cierre") {
    Cierre();
}

